<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: SPI Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="classSPI-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">SPI Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Handle SPI protocol.  
 <a href="classSPI.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="SPI_8h_source.html">SPI.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a2ba081c29fbdecc704c6bf00b24d5205"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSPI.html#a2ba081c29fbdecc704c6bf00b24d5205">SPI</a> ()</td></tr>
<tr class="memdesc:a2ba081c29fbdecc704c6bf00b24d5205"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct an instance of the class.  <a href="#a2ba081c29fbdecc704c6bf00b24d5205">More...</a><br /></td></tr>
<tr class="separator:a2ba081c29fbdecc704c6bf00b24d5205"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6babebf1ea3e8ff0330f43a3e2312ac4"><td class="memItemLeft" align="right" valign="top"><a id="a6babebf1ea3e8ff0330f43a3e2312ac4"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSPI.html#a6babebf1ea3e8ff0330f43a3e2312ac4">~SPI</a> ()</td></tr>
<tr class="memdesc:a6babebf1ea3e8ff0330f43a3e2312ac4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class instance destructor. <br /></td></tr>
<tr class="separator:a6babebf1ea3e8ff0330f43a3e2312ac4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a832556869c632024fe6ab92473854131"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSPI.html#a832556869c632024fe6ab92473854131">init</a> (int mosiPin=<a class="el" href="classSPI.html#a311aea82b4ba1b8b57ac88ec62c94bf2">DEFAULT_MOSI_PIN</a>, int misoPin=<a class="el" href="classSPI.html#af64304a498004d8abd46931cfbb5bba6">DEFAULT_MISO_PIN</a>, int clkPin=<a class="el" href="classSPI.html#a26f31b5eb7b69e66761d387116ea0003">DEFAULT_CLK_PIN</a>, int csPin=<a class="el" href="classSPI.html#a7ed47313c92be5762bb61a6d69a58d7e">DEFAULT_CS_PIN</a>)</td></tr>
<tr class="memdesc:a832556869c632024fe6ab92473854131"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize <a class="el" href="classSPI.html" title="Handle SPI protocol.">SPI</a>.  <a href="#a832556869c632024fe6ab92473854131">More...</a><br /></td></tr>
<tr class="separator:a832556869c632024fe6ab92473854131"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a85ec652a3a1eb453f6b9938a45b599c9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSPI.html#a85ec652a3a1eb453f6b9938a45b599c9">setHost</a> (spi_host_device_t host)</td></tr>
<tr class="memdesc:a85ec652a3a1eb453f6b9938a45b599c9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the <a class="el" href="classSPI.html" title="Handle SPI protocol.">SPI</a> host to use. Call this prior to <a class="el" href="classSPI.html#a832556869c632024fe6ab92473854131" title="Initialize SPI.">init()</a>.  <a href="#a85ec652a3a1eb453f6b9938a45b599c9">More...</a><br /></td></tr>
<tr class="separator:a85ec652a3a1eb453f6b9938a45b599c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3d0d6d9b84a7191b4a95971eee25f746"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSPI.html#a3d0d6d9b84a7191b4a95971eee25f746">transfer</a> (uint8_t *data, size_t dataLen)</td></tr>
<tr class="memdesc:a3d0d6d9b84a7191b4a95971eee25f746"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send and receive data through SPI. This is a blocking call.  <a href="#a3d0d6d9b84a7191b4a95971eee25f746">More...</a><br /></td></tr>
<tr class="separator:a3d0d6d9b84a7191b4a95971eee25f746"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff890367df7fa27734d18c772eb227df"><td class="memItemLeft" align="right" valign="top">uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSPI.html#aff890367df7fa27734d18c772eb227df">transferByte</a> (uint8_t value)</td></tr>
<tr class="memdesc:aff890367df7fa27734d18c772eb227df"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send and receive a single byte.  <a href="#aff890367df7fa27734d18c772eb227df">More...</a><br /></td></tr>
<tr class="separator:aff890367df7fa27734d18c772eb227df"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a311aea82b4ba1b8b57ac88ec62c94bf2"><td class="memItemLeft" align="right" valign="top"><a id="a311aea82b4ba1b8b57ac88ec62c94bf2"></a>
static const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSPI.html#a311aea82b4ba1b8b57ac88ec62c94bf2">DEFAULT_MOSI_PIN</a> = GPIO_NUM_13</td></tr>
<tr class="memdesc:a311aea82b4ba1b8b57ac88ec62c94bf2"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default MOSI pin. <br /></td></tr>
<tr class="separator:a311aea82b4ba1b8b57ac88ec62c94bf2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af64304a498004d8abd46931cfbb5bba6"><td class="memItemLeft" align="right" valign="top"><a id="af64304a498004d8abd46931cfbb5bba6"></a>
static const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSPI.html#af64304a498004d8abd46931cfbb5bba6">DEFAULT_MISO_PIN</a> = GPIO_NUM_12</td></tr>
<tr class="memdesc:af64304a498004d8abd46931cfbb5bba6"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default MISO pin. <br /></td></tr>
<tr class="separator:af64304a498004d8abd46931cfbb5bba6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a26f31b5eb7b69e66761d387116ea0003"><td class="memItemLeft" align="right" valign="top"><a id="a26f31b5eb7b69e66761d387116ea0003"></a>
static const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSPI.html#a26f31b5eb7b69e66761d387116ea0003">DEFAULT_CLK_PIN</a> = GPIO_NUM_14</td></tr>
<tr class="memdesc:a26f31b5eb7b69e66761d387116ea0003"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default CLK pin. <br /></td></tr>
<tr class="separator:a26f31b5eb7b69e66761d387116ea0003"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7ed47313c92be5762bb61a6d69a58d7e"><td class="memItemLeft" align="right" valign="top"><a id="a7ed47313c92be5762bb61a6d69a58d7e"></a>
static const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSPI.html#a7ed47313c92be5762bb61a6d69a58d7e">DEFAULT_CS_PIN</a> = GPIO_NUM_15</td></tr>
<tr class="memdesc:a7ed47313c92be5762bb61a6d69a58d7e"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default CS pin. <br /></td></tr>
<tr class="separator:a7ed47313c92be5762bb61a6d69a58d7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acebfbe004601caf512d1b5b84b1a0967"><td class="memItemLeft" align="right" valign="top"><a id="acebfbe004601caf512d1b5b84b1a0967"></a>
static const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSPI.html#acebfbe004601caf512d1b5b84b1a0967">PIN_NOT_SET</a> = -1</td></tr>
<tr class="memdesc:acebfbe004601caf512d1b5b84b1a0967"><td class="mdescLeft">&#160;</td><td class="mdescRight">Value of unset pin. <br /></td></tr>
<tr class="separator:acebfbe004601caf512d1b5b84b1a0967"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Handle SPI protocol. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a2ba081c29fbdecc704c6bf00b24d5205"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2ba081c29fbdecc704c6bf00b24d5205">&#9670;&nbsp;</a></span>SPI()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">SPI::SPI </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct an instance of the class. </p>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a832556869c632024fe6ab92473854131"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a832556869c632024fe6ab92473854131">&#9670;&nbsp;</a></span>init()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void SPI::init </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>mosiPin</em> = <code><a class="el" href="classSPI.html#a311aea82b4ba1b8b57ac88ec62c94bf2">DEFAULT_MOSI_PIN</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>misoPin</em> = <code><a class="el" href="classSPI.html#af64304a498004d8abd46931cfbb5bba6">DEFAULT_MISO_PIN</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>clkPin</em> = <code><a class="el" href="classSPI.html#a26f31b5eb7b69e66761d387116ea0003">DEFAULT_CLK_PIN</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>csPin</em> = <code><a class="el" href="classSPI.html#a7ed47313c92be5762bb61a6d69a58d7e">DEFAULT_CS_PIN</a></code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Initialize <a class="el" href="classSPI.html" title="Handle SPI protocol.">SPI</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">mosiPin</td><td>Pin to use for MOSI SPI function. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">misoPin</td><td>Pin to use for MISO SPI function. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">clkPin</td><td>Pin to use for CLK SPI function. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">csPin</td><td>Pin to use for CS SPI function. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a85ec652a3a1eb453f6b9938a45b599c9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a85ec652a3a1eb453f6b9938a45b599c9">&#9670;&nbsp;</a></span>setHost()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void SPI::setHost </td>
          <td>(</td>
          <td class="paramtype">spi_host_device_t&#160;</td>
          <td class="paramname"><em>host</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the <a class="el" href="classSPI.html" title="Handle SPI protocol.">SPI</a> host to use. Call this prior to <a class="el" href="classSPI.html#a832556869c632024fe6ab92473854131" title="Initialize SPI.">init()</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">host</td><td>The <a class="el" href="classSPI.html" title="Handle SPI protocol.">SPI</a> host to use. Either HSPI_HOST (default) or VSPI_HOST. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a3d0d6d9b84a7191b4a95971eee25f746"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3d0d6d9b84a7191b4a95971eee25f746">&#9670;&nbsp;</a></span>transfer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void SPI::transfer </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>dataLen</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send and receive data through SPI. This is a blocking call. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>A data buffer used to send and receive. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dataLen</td><td>The number of bytes to transmit and receive. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aff890367df7fa27734d18c772eb227df"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aff890367df7fa27734d18c772eb227df">&#9670;&nbsp;</a></span>transferByte()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint8_t SPI::transferByte </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send and receive a single byte. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">value</td><td>The byte to send. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The byte value received. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="SPI_8h_source.html">SPI.h</a></li>
<li>SPI.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
